-------------
-- LightRP
-- Rick Darkaliono aka DarkCybo1
-- Jan 22, 2007
-- Done Jan 26, 2007

-- This script isn't a representation of my skillz
-------------

DeriveGamemode( "sandbox" );

AddCSLuaFile( "cl_init.lua" );
AddCSLuaFile( "shared.lua" );
AddCSLuaFile( "cl_vgui.lua" );
AddCSLuaFile( "entity.lua" );
AddCSLuaFile( "cl_scoreboard.lua" );
AddCSLuaFile( "scoreboard/admin_buttons.lua" );
AddCSLuaFile( "scoreboard/player_frame.lua" );
AddCSLuaFile( "scoreboard/player_infocard.lua" );
AddCSLuaFile( "scoreboard/player_row.lua" );
AddCSLuaFile( "scoreboard/scoreboard.lua" );
AddCSLuaFile( "scoreboard/vote_button.lua" );
AddCSLuaFile( "cl_helpvgui.lua" );

include( "help.lua" );
include( "player.lua" );
include( "shared.lua" );
include( "chat.lua" );
include( "rplol.lua" );
include( "util.lua" );
include( "votes.lua" );
include( "admins.lua" );
include( "admincc.lua" );
include( "entity.lua" );
include( "bannedprops.lua" );
include( "commands.lua" );

AddHelpCategory( HELP_CATEGORY_CHATCMD, "Chat Commands" );
AddHelpCategory( HELP_CATEGORY_CONCMD, "Console Commands" );
AddHelpCategory( HELP_CATEGORY_ADMINTOGGLE, "Admin Toggle Commands (1 or 0!)" );
AddHelpCategory( HELP_CATEGORY_ADMINCMD, "Admin Console Commands" );

CSFiles = { }

LRP = { }
CfgVars = { }

function includeCS( dir )

	AddCSLuaFile( dir );
	table.insert( CSFiles, dir );

end

local files = file.Find( "../gamemodes/LightRP/gamemode/modules/*.lua" );
for k, v in pairs( files ) do

	include( "modules/" .. v );

end

----------------------------------------
-- CONFIGURABLE SHIT 
-- HEY HEY HEY, YOU CAN EDIT THIS PART WITHOUT FEELING GUILTY!
----------------------------------------

-- 1 or 0
-- 1 FOR YES
-- 0 FOR NO

CfgVars["ooc"] = 1; --OOC allowed
CfgVars["alltalk"] = 1; --All talk allowed
CfgVars["crosshair"] = 1; --Crosshairs enabled?
CfgVars["maxow"] = 99; --Max number of OW you can have
CfgVars["maxcps"] = 99; --Max number of CPs you can have
CfgVars["strictsuicide"] = 0; --Should players respawn where they suicided (regardless of they're arrested or not)
CfgVars["propertytax"] = 0; --Property taxes
CfgVars["cit_propertytax"] = 0; --Just citizens have to pay property tax?
CfgVars["paydelay"] = 150; --Pay day delay (in seconds)
CfgVars["banprops"] = 1; --Prop banning
CfgVars["toolgun"] = 1; --Tool gun enabled?
CfgVars["allowedprops"] = 0; --Should players be only able to spawn "allowed" props?
CfgVars["propspawning"] = 1; --Prop spawning enabled?
CfgVars["adminsents"] = 0; --Should all SENTs be admin only?
CfgVars["adminsweps"] = 0; --Should all sweps be admin only?
CfgVars["cpvote"] = 1; --Should people be able to use /votecop?
CfgVars["owvote"] = 0; --Should people be able to use /voteow?
CfgVars["maxow"] = 3; --Maximum amount of OW you can have
CfgVars["enforceplayermodel"] = 1; --Should player models be enforced? (Bans using player models like zombie/combine/etc)
CfgVars["proppaying"] = 0; --Should players pay for props
CfgVars["propcost"] = 10; --Prop cost
CfgVars["letters"] = 1; --Allow letter writing
CfgVars["cpvoting"] = 1; --Allow CP voting
CfgVars["owvoting"] = 0; --Allow OW voting
CfgVars["cptoowonly"] = 1; --Only CPs can do /voteow

SetGlobalInt( "nametag", 1 ); --Should names show?
SetGlobalInt( "jobtag", 1 ); --Should jobs show?
SetGlobalInt( "globalshow", 0 ); --Should we see player info from across the map?
SetGlobalString( "cmdprefix", "/" ); --Prefix before any chat commands

----------------------------------------
----------------------------------------

if( not file.IsDir( "LightRP/" ) ) then

	file.CreateDir( "LightRP" );

end

if( not file.Exists( "LightRP/WHAT_YOU_CAN_DO_IN_THIS_FOLDER.txt" ) ) then

	local str = [[
	In this folder, you can create a file named servercfg.txt.  
	You can put in RP admin console commands in this file, and they'll be executed whenever the server starts.  
	Meaning you don't have to edit the script to change the default cvars!
	
	Example content of what can be in servercfg.txt:
	
	rp_chatprefix !
	rp_propertytax 1
	rp_citpropertytax 1
	rp_toolgun 0
	rp_letters 0
	]]
	
	file.Write( "LightRP/WHAT_YOU_CAN_DO_IN_THIS_FOLDER.txt" , str );

end

if( file.Exists( "LightRP/servercfg.txt" ) ) then

	local cmds = string.Explode( "\n", file.Read( "LightRP/servercfg.txt" ) );
	
	for k, v in pairs( cmds ) do
	
		game.ConsoleCommand( v .. "\n" );
	
	end

end

GenerateChatCommandHelp();

function GM:Initialize()

	self.BaseClass:Initialize();

end

for k, v in pairs( player.GetAll() ) do

	v:NewData();

end

AddHelpLabel( -1, HELP_CATEGORY_CONCMD, "gm_showhelp - Toggle help menu (bind this to F1 if you haven't already)" );
AddHelpLabel( -1, HELP_CATEGORY_CONCMD, "gm_showspare1 - Toggle vote clicker (bind this to F3 if you haven't already)" );
AddHelpLabel( -1, HELP_CATEGORY_CONCMD, "gm_showspare2 - Own/unown doors (bind this to F4 if you haven't already)" );

function ShowSpare1( ply )

	ply:ConCommand( "gm_showspare1\n" );

end
concommand.Add( "gm_spare1", ShowSpare1 );

function ShowSpare2( ply )

	ply:ConCommand( "gm_showspare2\n" );

end
concommand.Add( "gm_spare2", ShowSpare2 );

function GM:ShowHelp( ply )

	umsg.Start( "ToggleHelp", ply ); umsg.End();

end

GM.Name = "LightRP";
GM.Author = "Rick Darkaliono";

