
VoteCopOn = false;

function GetHelp( ply, args )

	umsg.Start( "ToggleHelp", ply ); umsg.End();
	
	return "";

end
AddChatCommand( "/help", GetHelp );

function WriteLetter( ply, args )

	if( CfgVars["letters"] == 0 ) then
		
		Notify( ply, 1, 4, "Letter writing disabled" );
		return "";
	
	end
	
	if( CurTime() - ply:GetTable().LastLetterMade < 3 ) then
	
		Notify( ply, 1, 4, "Wait another " .. math.ceil( 3 - ( CurTime() - ply:GetTable().LastLetterMade ) ) .. " seconds to make a letter" );
		return "";
	
	end

	ply:GetTable().LastLetterMade = CurTime();
	
	local ftext = string.gsub( args, "//", "\n" );
	
	local tr = { }
	tr.start = ply:EyePos();
	tr.endpos = ply:EyePos() + 95 * ply:GetAimVector();
	tr.filter = ply;
	local trace = util.TraceLine( tr );
	
	local letter = ents.Create( "prop_physics" );
		letter:SetModel( "models/props_c17/paper01.mdl" );
		letter:SetPos( trace.HitPos );
	letter:Spawn();
	
	letter:GetTable().Letter = true;
	letter:SetNWInt( "type", 1 );
	letter:SetNWString( "content", ftext );
	
	PrintMessageAll( 2, ply:Nick() .. " created a letter." );
	ply:PrintMessage( 2, "CREATED LETTER:\n" .. args );
	
	return "";

end
AddChatCommand( "/write", WriteLetter );


function TypeLetter( ply, args )

	if( CfgVars["letters"] == 0 ) then
		
		Notify( ply, 1, 4, "Letter typing disabled" );
		return "";
	
	end
	
	if( CurTime() - ply:GetTable().LastLetterMade < 3 ) then
	
		Notify( ply, 1, 4, "Wait another " .. math.ceil( 3 - ( CurTime() - ply:GetTable().LastLetterMade ) ) .. " seconds to make a letter" );
		return "";
	
	end

	ply:GetTable().LastLetterMade = CurTime();

	local ftext = string.gsub( args, "//", "\n" );
	
	local tr = { }
	tr.start = ply:EyePos();
	tr.endpos = ply:EyePos() + 95 * ply:GetAimVector();
	tr.filter = ply;
	local trace = util.TraceLine( tr );
	
	local letter = ents.Create( "prop_physics" );
		letter:SetModel( "models/props_c17/paper01.mdl" );
		letter:SetPos( trace.HitPos );
	letter:Spawn();
	
	letter:GetTable().Letter = true;
	letter:SetNWInt( "type", 2 );
	letter:SetNWString( "content", ftext );
	
	PrintMessageAll( 2, ply:Nick() .. " created a letter." );
	ply:PrintMessage( 2, "CREATED LETTER:\n" .. args );
	
	return "";

end
AddChatCommand( "/type", TypeLetter );

function ChangeJob( ply, args )
	
    if( args == "" ) then return ""; end
	
	NotifyAll( 2, 4, ply:Nick() .. " has set job to " .. args .. "!" );
	ply:UpdateJob( args );
	
	return "";

end
AddChatCommand( "/job", ChangeJob );

function PM( ply, args )

	local namepos = string.find( args, " " );
	if( not namepos ) then return ""; end
	
	local name = string.sub( args, 1, namepos - 1 );
	local msg = string.sub( args, namepos + 1 );
	
	target = FindPlayer( name );
		
	if( target ) then
	
		target:PrintMessage( 2, ply:Nick() .. ": (PM) " .. msg );
		target:PrintMessage( 3, ply:Nick() .. ": (PM) " .. msg );
		
		ply:PrintMessage( 2, ply:Nick() .. ": (PM) " .. msg );
		ply:PrintMessage( 3, ply:Nick() .. ": (PM) " .. msg );
		
	else
		
		Notify( ply, 1, 3, "Could not find player: " .. name );
		
	end
	
	return "";

end
AddChatCommand( "/pm", PM );


function Whisper( ply, args )

	TalkToRange( "(WHISPER)" .. ply:Nick() .. ": " .. args, ply:EyePos(), 90 );
	
	return "";

end
AddChatCommand( "/w", Whisper );


function Yell( ply, args )

	TalkToRange( "(YELL)" .. ply:Nick() .. ": " .. args, ply:EyePos(), 550 );
	
	return "";

end
AddChatCommand( "/y", Yell );

function OOC( ply, args )

	if( CfgVars["ooc"] == 0 ) then 
		Notify( ply, 1, 3, "OOC is disabled" );
		return "";
	end

	return "(OOC) " .. args;

end
AddChatCommand( "//", OOC, true );
AddChatCommand( "/a ", OOC, true );
AddChatCommand( "/ooc", OOC, true );


function GiveMoney( ply, args )
	
    if( args == "" ) then return ""; end
	
	local trace = ply:GetEyeTrace();
	
	if( trace.Entity:IsValid() and trace.Entity:IsPlayer() and trace.Entity:GetPos():Distance( ply:GetPos() ) < 105 ) then
	
		local amount = tonumber( args );
		
		if( not ply:CanAfford( amount ) ) then
		
			Notify( ply, 1, 3, "Cannot afford this" );
			return "";
		
		end
		
		trace.Entity:AddMoney( amount );
		ply:AddMoney( amount * -1 );
		
		Notify( trace.Entity, 0, 4, ply:Nick() .. " has given you " .. amount .. " bucks!" );
		Notify( ply, 0, 4, "Gave " .. trace.Entity:Nick() .. " " .. amount .. " bucks!" );
		
	else
	
		Notify( ply, 1, 3, "Must be looking at and be within distance of another player" );
		
	end
	
	return "";

end
AddChatCommand( "/give", GiveMoney );


function DropMoney( ply, args )
	
    if( args == "" ) then return ""; end
	
	local amount = tonumber( args );
	
	if( not ply:CanAfford( amount ) ) then
		
		Notify( ply, 1, 3, "Cannot afford this" );
		return "";
		
	end
	
	if( amount < 50 ) then
	
		Notify( ply, 1, 4, "Invalid amount of money! Must be atleast 50 bucks" );
		return "";
	
	end
	
	ply:AddMoney( amount * -1 );
	
	local trace = { }
	
	trace.start = ply:EyePos();
	trace.endpos = trace.start + ply:GetAimVector() * 85;
	trace.filter = ply;
	
	local tr = util.TraceLine( trace );
	
	local moneybag = ents.Create( "prop_physics" );
	moneybag:SetModel( "models/props/cs_assault/money.mdl" );
	moneybag:SetPos( tr.HitPos );
	moneybag:Spawn();
	
	moneybag:GetTable().MoneyBag = true;
	moneybag:GetTable().Amount = amount;
	
	return "";

end
AddChatCommand( "/drop", DropMoney );


function SetDoorTitle( ply, args )

	local trace = ply:GetEyeTrace();
	
	if( trace.Entity:IsValid() and trace.Entity:IsOwnable() and ply:GetPos():Distance( trace.Entity:GetPos() ) < 110 ) then
	
		if( trace.Entity:OwnedBy( ply ) ) then
			trace.Entity:SetNWString( "title", args );
		else
			Notify( ply, 1, 3, "You don't own this!" );
		end
	
	end
	
	return "";

end
AddChatCommand( "/title", SetDoorTitle );

function RemoveDoorOwner( ply, args )

	local trace = ply:GetEyeTrace();
	
	if( trace.Entity:IsValid() and trace.Entity:IsOwnable() and ply:GetPos():Distance( trace.Entity:GetPos() ) < 110 ) then
	
		target = FindPlayer( args );
		
		if( target ) then
	
			if( trace.Entity:OwnedBy( ply ) ) then
				if( trace.Entity:AllowedToOwn( target ) ) then
					trace.Entity:RemoveAllowed( target );
				end
				
				if( trace.Entity:OwnedBy( target ) ) then
					trace.Entity:RemoveOwner( target );
				end
			else
				Notify( ply, 1, 3, "You don't own this!" );
			end
		
		else
		
			Notify( ply, 1, 3, "Could not find player: " .. args );
		
		end
		
	end
	
	return "";

end
AddChatCommand( "/removeowner", RemoveDoorOwner );


function AddDoorOwner( ply, args )

	local trace = ply:GetEyeTrace();
	
	if( trace.Entity:IsValid() and trace.Entity:IsOwnable() and ply:GetPos():Distance( trace.Entity:GetPos() ) < 110 ) then
	
		target = FindPlayer( args );
		
		if( target ) then
	
			if( trace.Entity:OwnedBy( ply ) ) then
				if( not trace.Entity:OwnedBy( target ) and not trace.Entity:AllowedToOwn( target ) ) then
					trace.Entity:AddAllowed( target );
				else
					Notify( ply, 1, 3, "Player already owns this door, or is allowed to own!" );
				end
			else
				Notify( ply, 1, 3, "You don't own this!" );
			end
		
		else
		
			Notify( ply, 1, 3, "Could not find player: " .. args );
		
		end
		
	end
	
	return "";

end
AddChatCommand( "/addowner", AddDoorOwner );

function FinishVoteOW( choice, ply )

	VoteCopOn = false;

	if( choice == 1 ) then
	
		ply:SetTeam( 3 );
		ply:UpdateJob( "OverWatch" );
		ply:KillSilent();
		
		NotifyAll( 1, 4, ply:Nick() .. " has been made OverWatch!" );
	
	else
	
		NotifyAll( 1, 4, ply:Nick() .. " has not been made OverWatch!" );
	
	end

end

function FinishVoteCop( choice, ply )

	VoteCopOn = false;

	if( choice == 1 ) then
	
		ply:SetTeam( 2 );
		ply:UpdateJob( "Civil Protection" );
		ply:KillSilent();
		
		NotifyAll( 1, 4, ply:Nick() .. " has been made Civil Protection!" );
	
	else
	
		NotifyAll( 1, 4, ply:Nick() .. " has not been made Civil Protection!" );
	
	end

end

function DoVoteOW( ply, args )

	if( CfgVars["owvoting"] == 0 ) then
	
		Notify( ply, 1, 4,  "OW voting is disabled!" );
		return "";
	
	end

	if( CurTime() - ply:GetTable().LastVoteCop < 80 ) then
	
		Notify( ply, 1, 4, "Wait another " .. math.ceil( 80 - ( CurTime() - ply:GetTable().LastVoteCop ) ) .. " seconds to voteow!" );
		return "";
	
	end
	
	if( VoteCopOn ) then
	
		Notify( ply, 1, 4,  "There is already a vote!" );
		return "";
	
	end
	
	if( CfgVars["cptoowonly"] == 1 ) then
	
		if( ply:Team() == 1 ) then
		
			Notify( ply, 1, 4,  "You have to be in the civil protection!" );
			return "";	
		
		end
		
	end
	
	if( ply:Team() == 3 ) then
	
		Notify( ply, 1, 4,  "You're already in the OverWatch!" );
		return "";
	
	end
	
	if( team.NumPlayers( 3 ) >= CfgVars["maxow"] ) then
	
		Notify( ply, 1, 4,  "Max number of OW is: " .. CfgVars["maxow"] );
		return "";	
	
	end
	
	vote:Create( ply:Nick() .. ":\nwants to be OverWatch", ply:EntIndex() .. "votecop", ply, 12, FinishVoteOW );
	ply:GetTable().LastVoteCop = CurTime();
	VoteCopOn = true;
	
	return "";

end
AddChatCommand( "/voteow", DoVoteOW );

function DoVoteCop( ply, args )

	if( CfgVars["cpvoting"] == 0 ) then
	
		Notify( ply, 1, 4,  "Copvoting is disabled!" );
		return "";
	
	end

	if( CurTime() - ply:GetTable().LastVoteCop < 60 ) then
	
		Notify( ply, 1, 4, "Wait another " .. math.ceil( 60 - ( CurTime() - ply:GetTable().LastVoteCop ) ) .. " seconds to votecop!" );
		return "";
	
	end
	
	if( VoteCopOn ) then
	
		Notify( ply, 1, 4,  "There is already a votecop!" );
		return "";
	
	end
	
	if( ply:Team() == 2 or ply:Team() == 3 ) then
	
		Notify( ply, 1, 4,  "You're already in the Combine!" );
		return "";	
	
	end
	
	if( team.NumPlayers( 2 ) >= CfgVars["maxcps"] ) then
	
		Notify( ply, 1, 4,  "Max number of CPs is: " .. CfgVars["maxcps"] );
		return "";	
	
	end
	
	vote:Create( ply:Nick() .. ":\nwants to be a CP", ply:EntIndex() .. "votecop", ply, 12, FinishVoteCop );
	ply:GetTable().LastVoteCop = CurTime();
	VoteCopOn = true;
	
	return "";

end
AddChatCommand( "/votecop", DoVoteCop );


function MakeOW( ply, args )

	if( Admins[ply:SteamID()] or OW[ply:SteamID()] ) then
	
		ply:SetTeam( 3 );
		ply:UpdateJob( "OverWatch" );
		ply:KillSilent();
		
	end
	
	return "";

end
AddChatCommand( "/ow", MakeOW );

function MakeCitizen( ply, args )

	if( ply:Team() ~= 1 ) then
	
		ply:SetTeam( 1 );
		ply:UpdateJob( "Citizen" );
		ply:KillSilent();
	
	else
	
		Notify( ply, 0, 3, "You're already a citizen!" );
	
	end
	
	return "";

end
AddChatCommand( "/citizen", MakeCitizen );


function MakeCP( ply, args )

	if( CP[ply:SteamID()] or Admins[ply:SteamID()] or OW[ply:SteamID()] ) then
	
		ply:SetTeam( 2 );
		ply:UpdateJob( "Civil Protection" );
		ply:KillSilent();
		
	end
	
	return "";

end
AddChatCommand( "/cp", MakeCP );


function CombineRadio( ply, args )

	if( ply:Team() == 2 or ply:Team() == 3 ) then
	
		for k, v in pairs( player.GetAll() ) do
		
			if( v:Team() == 2 or v:Team() == 3 ) then
			
				v:ChatPrint( ply:Nick() .. ": (RADIO) " .. args );
				v:PrintMessage( 2, ply:Nick() .. ": (RADIO) " .. args );
			
			end
		
		end
	
	end
	
	return "";

end
AddChatCommand( "/r", CombineRadio );

function CombineRequest( ply, args )

	if( ply:Team() ~= 2 and ply:Team() ~= 3 ) then
	
		ply:ChatPrint( ply:Nick() .. ": (REQUEST!) " .. args );
		ply:PrintMessage( 2, ply:Nick() .. ": (REQUEST!) " .. args );	
	
	end
	
	for k, v in pairs( player.GetAll() ) do
		
		if( v:Team() == 2 or v:Team() == 3 ) then
			
			v:ChatPrint( ply:Nick() .. ": (REQUEST!) " .. args );
			v:PrintMessage( 2, ply:Nick() .. ": (REQUEST!) " .. args );
			
		end
		
	end
	
	
	return "";

end
AddChatCommand( "/cr", CombineRequest );

function GM:PhysgunPickup( ply, ent )

	if( ent:IsPlayer() or ent:IsDoor() ) then return false; end

	local class = ent:GetClass();
	
	if( Admins[ply:SteamID()] ) then return true; end
	
	if( class ~= "func_physbox" and class ~= "prop_physics" and class ~= "prop_physics_multiplayer" and
		class ~= "prop_vehicle_prisoner_pod" ) then
		return false;
	end
	
	return true;

end

function GM:PlayerSpawnProp( ply, model )

	if( not self.BaseClass:PlayerSpawnProp( ply, model ) ) then return false; end
	
	local allowed = false;
	
	if( ply:GetTable().Arrested ) then return false; end
	if( ( CfgVars["allowedprops"] == 0 and CfgVars["banprops"] == 0 ) or Admins[ply:SteamID()] ) then allowed = true; end
	if( CfgVars["propspawning"] == 0 ) then return false; end
	
	if( CfgVars["allowedprops"] == 1 ) then
	
		for k, v in pairs( AllowedProps ) do
		
			if( v == model ) then allowed = true; end
		
		end
		
	end
	
	if( CfgVars["banprops"] == 1 ) then
	
		for k, v in pairs( BannedProps ) do
		
			if( v == model ) then return false; end
		
		end
		
	end
	
	if( allowed ) then
	
		if( CfgVars["proppaying"] == 1 ) then
		
			if( ply:CanAfford( CfgVars["propcost"] ) ) then
			
				Notify( ply, 1, 4, "Deducted $" .. CfgVars["propcost"] );
				ply:AddMoney( -CfgVars["propcost"] );
				
				return true;
			
			else
			
				Notify( ply, 1, 4, "Need $" .. CfgVars["propcost"] );
				return false;
			
			end
		
		else
		
			return true;
		
		end
	
	end
		
	return true;

end

function GM:SetupMove( ply, move )

	if( ply == nil or not ply:Alive() ) then
		return;
	end
	
	if( ply:Crouching() ) then
		
		move:SetMaxClientSpeed( 240 );
		return;	
	
	end
	
	if( ply:GetTable().Arrested ) then
	
		move:SetMaxClientSpeed( 210 );
		return;	
	
	end
	
	if( ply:KeyDown( IN_SPEED ) ) then
	
		move:SetMaxClientSpeed( 350 );
		return;
		
	elseif( ply:GetVelocity():Length() > 10 ) then
	
		move:SetMaxClientSpeed( 230 );
		return;	
	
	end
	

end


function GM:ShowSpare1( ply )

	umsg.Start( "ToggleClicker", ply ); umsg.End();

end

function GM:ShowSpare2( ply )
	
	local trace = ply:GetEyeTrace();
	
	if( trace.Entity:IsValid() and trace.Entity:IsOwnable() and ply:GetPos():Distance( trace.Entity:GetPos() ) < 110 ) then
	
		if( trace.Entity:OwnedBy( ply ) ) then
			Notify( ply, 1, 4, "You've unowned this door!" );
			trace.Entity:UnOwn( ply );
			ply:GetTable().Owned[trace.Entity:EntIndex()] = nil;
			ply:GetTable().OwnedNum = ply:GetTable().OwnedNum - 1;
		else
			
			if( trace.Entity:IsOwned() and not trace.Entity:AllowedToOwn( ply ) ) then
			
				Notify( ply, 1, 3, "Already owned" );
				return;
			
			end
			
			if( not ply:CanAfford( 30 ) ) then
		
				Notify( ply, 1, 4, "You cannot afford this!" );
				return;
		
			end
			
			ply:AddMoney( -30 );
		
			Notify( ply, 1, 4, "You've owned this door for 30 bucks!" );
			
			trace.Entity:Own( ply );
			
			if( ply:GetTable().OwnedNum == 0 ) then
				timer.Create( ply:SteamID() .. "propertytax", 270, 0, ply.DoPropertyTax, ply );
			end
			
			ply:GetTable().OwnedNum = ply:GetTable().OwnedNum + 1;
			
			ply:GetTable().Owned[trace.Entity:EntIndex()] = trace.Entity;
			
		end
		
	end

end

function GM:KeyPress( ply, code )

	self.BaseClass:KeyPress( ply, code );
	
	if( code == IN_USE ) then
	
		local trace = { }
	
		trace.start = ply:EyePos();
		trace.endpos = trace.start + ply:GetAimVector() * 95;
		trace.filter = ply;
		
		local tr = util.TraceLine( trace );

		if( tr.Entity:IsValid() and not ply:KeyDown( IN_ATTACK ) ) then
		
			if( tr.Entity:GetTable().Letter ) then
	
				umsg.Start( "ShowLetter", ply );
					umsg.Short( tr.Entity:GetNWInt( "type" ) );
					umsg.Vector( tr.Entity:GetPos() );
					umsg.String( tr.Entity:GetNWString( "content" ) );
				umsg.End();
			
			end

			if( tr.Entity:GetTable().MoneyBag ) then
	
				Notify( ply, 0, 4, "You found " .. tr.Entity:GetTable().Amount .. " bucks" );
				ply:AddMoney( tr.Entity:GetTable().Amount );
				
				tr.Entity:Remove();
			
			end
		
		else
		
			umsg.Start( "KillLetter", ply ); umsg.End();
		
		end
	
	end

end
